<!--
 Copyright (C) 2024 bAvenir

 This program and the accompanying materials are made
 available under the terms of the Eclipse Public License 2.0
 which is available at https://www.eclipse.org/legal/epl-2.0/

 SPDX-License-Identifier: EPL-2.0
-->

<app-selection-skeleton *ngIf="loading; else loaded"> </app-selection-skeleton>
<ng-template #loaded>
  <div class="w-full h-full flex gap-3">
    <div class="w-[calc(380px)] relative">
      <div class="w-full h-full">
        <div class="h-full flex flex-col w-full" [ngClass]="{ 'pb-3': action }">
          <div class="pb-5 w-full flex items-center justify-end gap-3">
            <div *ngIf="search && !error">
              <span class="p-input-icon-left">
                <i class="pi pi-search" [ngClass]="{ 'opacity-60': disabled }"></i>
                <input
                  [(ngModel)]="searchText"
                  [disabled]="disabled"
                  type="text"
                  pInputText
                  placeholder="Search..."
                  (ngModelChange)="onSearchChange($event)"
                />
              </span>
            </div>
            <div class="grow">
              <ng-template *ngIf="leading" [ngTemplateOutlet]="leading"></ng-template>
            </div>
          </div>
          <div
            *ngIf="!this.error && this.itemsToDisplay.length > 0"
            class="w-full flex justify-end pb-4 text-sm text-text-300 items-center px-3 selection-container"
          >
            <div *ngIf="selectable" class="grow shrink-0 flex items-center">
              <p-checkbox
                [(ngModel)]="allSelected"
                inputId="select-all"
                [binary]="true"
                (onChange)="toggleAll()"
              ></p-checkbox>
              <label for="select-all" class="cursor-pointer pl-4">Select all</label>
              <div *ngIf="selectionAction" class="ml-2">
                <ng-template [ngTemplateOutlet]="selectionAction"></ng-template>
              </div>
            </div>
            <div>{{ length }}</div>
          </div>
          <div *ngIf="error; else notError">
            <ng-template
              *ngIf="onError"
              [ngTemplateOutlet]="onError"
              [ngTemplateOutletContext]="{ $implicit: error }"
            ></ng-template>
          </div>
          <ng-template #notError>
            <ng-container *ngIf="itemsToDisplay.length > 0; else noItems">
              <cdk-virtual-scroll-viewport
                #virtualScroller
                *ngIf="virtualScrollerSettings"
                [itemSize]="virtualScrollerSettings.itemSize"
                class="h-full flex flex-col overflow-y-auto border-t border-borderGrey pb-32"
              >
                <div
                  *cdkVirtualFor="let item of itemsToDisplay; let i = index"
                  class="px-3 py-5 group hover:bg-primary-50 cursor-pointer flex gap-4 items-center border-b border-borderGrey relative"
                  (click)="pickItem(item)"
                  [ngClass]="{ '!bg-primary-50': pickedItem == item, 'mb-32': i === itemsToDisplay.length - 1 }"
                >
                  <div *ngIf="selectable" class="shrink-0">
                    <p-checkbox
                      name="items"
                      [(ngModel)]="selectedItems"
                      [value]="item"
                      (onChange)="$event.originalEvent?.stopPropagation(); toggleOne()"
                    ></p-checkbox>
                  </div>
                  <div class="grow">
                    <ng-template
                      *ngIf="preview"
                      [ngTemplateOutlet]="preview"
                      [ngTemplateOutletContext]="{ $implicit: item }"
                    ></ng-template>
                  </div>
                </div>
              </cdk-virtual-scroll-viewport>
              <div
                *ngIf="!virtualScrollerSettings"
                class="grow flex flex-col overflow-y-auto border-t border-borderGrey pb-32"
              >
                <div *ngFor="let item of itemsToDisplay">
                  <div
                    class="px-3 py-5 hover:bg-primary-50 cursor-pointer flex gap-4 items-center border-b border-borderGrey"
                    (click)="pickItem(item)"
                    [ngClass]="{ 'bg-primary-50': item === pickedItem }"
                  >
                    <div *ngIf="selectable" class="shrink-0">
                      <p-checkbox
                        name="items"
                        [(ngModel)]="selectedItems"
                        [value]="item"
                        (onChange)="toggleOne()"
                      ></p-checkbox>
                    </div>
                    <div class="grow">
                      <ng-template
                        *ngIf="preview"
                        [ngTemplateOutlet]="preview"
                        [ngTemplateOutletContext]="{ $implicit: item }"
                      ></ng-template>
                    </div>
                  </div>
                </div>
              </div>
            </ng-container>
            <ng-template #noItems>
              <ng-template *ngIf="onEmpty" [ngTemplateOutlet]="onEmpty"></ng-template>
            </ng-template>
          </ng-template>
        </div>
      </div>
      <div *ngIf="action && !this.error" class="absolute bottom-0 left-0 w-full pointer-events-none h-40 pr-2">
        <div class="fade-container w-full h-full flex items-end justify-center">
          <div class="pointer-events-auto pb-6">
            <ng-template [ngTemplateOutlet]="action"></ng-template>
          </div>
        </div>
      </div>
    </div>
    <div class="h-full pt-6 pb-6">
      <div class="w-0.5 h-full bg-borderGrey rounded-sm"></div>
    </div>
    <div *ngIf="detail" class="grow h-full overflow-y-auto">
      <ng-template [ngTemplateOutlet]="detail" [ngTemplateOutletContext]="{ $implicit: pickedItem }"></ng-template>
    </div>
  </div>
</ng-template>
